Package de.dfki.lt.freetts.en.us

# Class MbrolaVoice

java.lang.Object
com.sun.speech.freetts.Voice
com.sun.speech.freetts.en.us.CMUVoice
de.dfki.lt.freetts.en.us.MbrolaVoice

All Implemented Interfaces:
  `Dumpable`, `UtteranceProcessor`

public class MbrolaVoice extends CMUVoice
Defines an unlimited-domain diphone synthesis based voice using the MBROLA synthesis.

## Field Summary

### Fields inherited from class com.sun.speech.freetts.Voice

`DATABASE_NAME, DEFAULT_AUDIO_PLAYER, DEFAULT_AUDIO_PLAYER_DEFAULT, FEATURE_JOIN_TYPE, FEATURE_SILENCE, PROP_PREFIX`

## Constructor Summary

Constructors
Constructor
Description
`MbrolaVoice(String databaseDirectory, String database, float rate, float pitch, float range, String name, Gender gender, Age age, String description, Locale locale, String domain, String organization, CMULexicon lexicon)`
Creates an MbrolaVoice.

## Method Summary

Modifier and Type
Method
Description
`protected UtteranceProcessor`
`getAudioOutput()`
Returns the audio output used by this voice.
`String`
`getDatabase()`
Returns the absolute file name of the Voice database this MbrolaVoice uses.
`String`
`getMbrolaBase()`
Returns the absolute name of the MBROLA directory.
`String`
`getMbrolaBinary()`
Returns the absolute file name of the MBROLA binary.
`protected String[]`
`getMbrolaCommand()`
Returns the command line that invokes the MBROLA executable.
`String`
`getRenameList()`
Returns the absolute file name of the MBROLA phonetic symbols rename table.
`protected URL`
`getResource(String resource)`
Get a resource for this voice.
`protected UtteranceProcessor`
`getUnitConcatenator()`
Returns the unit concatenator to be used by this voice.
`protected UtteranceProcessor`
`getUnitSelector()`
Returns the unit selector to be used by this voice.
`String`
`toString()`
Converts this object to a string

### Methods inherited from class com.sun.speech.freetts.en.us.CMUVoice

`getPhoneFeature, getPitchmarkGenerator, getPostLexicalAnalyzer, getTokenizer, loader, setupFeatureProcessors, setupFeatureSet, setupUtteranceProcessors`

### Methods inherited from class com.sun.speech.freetts.Voice

`addFeatureProcessor, allocate, createOutputThread, deallocate, dump, dumpProcessors, endBatch, getAge, getAudioPlayer, getDefaultAudioPlayer, getDescription, getDomain, getDurationStretch, getFeatureProcessor, getFeatures, getGender, getLexicon, getLocale, getName, getOrganization, getOutputQueue, getPitch, getPitchRange, getPitchShift, getRate, getRunTitle, getStyle, getUtteranceProcessors, getVolume, getWaveDumpFile, isDetailedMetrics, isDumpRelations, isDumpUtterance, isLoaded, isMetrics, load, processNode, processUtterance, setAge, setAudioPlayer, setDescription, setDetailedMetrics, setDomain, setDumpRelations, setDumpUtterance, setDurationStretch, setGender, setLexicon, setLoaded, setLocale, setMetrics, setName, setOrganization, setOutputQueue, setPitch, setPitchRange, setPitchShift, setRate, setRunTitle, setStyle, setVolume, setWaveDumpFile, speak, speak, speak, speak, startBatch`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### MbrolaVoice

public MbrolaVoice(String databaseDirectory, String database, float rate, float pitch, float range, String name, Gender gender, Age age, String description, Locale locale, String domain, String organization, CMULexicon lexicon)
Creates an MbrolaVoice.

Parameters:
  `databaseDirectory` - the directory within the MBROLA directory where the voice database of this voice is located
  `database` - the name of the voice database of this voice
  `rate` - the rate of the voice
  `pitch` - the pitch of the voice
  `range` - the range of the voice
  `name` - the name of the voice
  `gender` - the gender of the voice
  `age` - the age of the voice
  `description` - a human-readable string providing a description that can be displayed for the users.
  `locale` - the locale of the voice
  `domain` - the domain of this voice. For example,
  `organization` - the organization which created the voice
  `lexicon` - the lexicon to use

## Method Details

### getUnitSelector

protected UtteranceProcessor getUnitSelector() throws IOException
Returns the unit selector to be used by this voice. Derived voices typically override this to customize behaviors.

Overrides:
  `getUnitSelector` in class `CMUVoice`
Returns:
  the unit selector
Throws:
  `IOException` - if an IO error occurs while getting processor

### getMbrolaCommand

protected String[] getMbrolaCommand()
Returns the command line that invokes the MBROLA executable. The command will be in the form of:

     {mbrolaExecutable} -e -R {mbrolaRenameList} {mbrolaVoiceDB}
     - -.raw

### getMbrolaBase

public String getMbrolaBase()
Returns the absolute name of the MBROLA directory.

Returns:
  the absolute name of the MBROLA directory

### getMbrolaBinary

public String getMbrolaBinary()
Returns the absolute file name of the MBROLA binary.

Returns:
  the absolute file name of the MBROLA binary

### getRenameList

public String getRenameList()
Returns the absolute file name of the MBROLA phonetic symbols rename table.

Returns:
  the absolute file name of the rename table

### getDatabase

public String getDatabase()
Returns the absolute file name of the Voice database this MbrolaVoice uses.

Returns:
  the absolute file name of the Voice database

### getUnitConcatenator

protected UtteranceProcessor getUnitConcatenator() throws IOException
Returns the unit concatenator to be used by this voice. This method constructs the command line with which the MBROLA binary will be called, and initialises the MbrolaCaller accordingly.

Overrides:
  `getUnitConcatenator` in class `CMUVoice`
Returns:
  the unit conatenator
Throws:
  `IOException` - if an IO error occurs while getting processor

### getAudioOutput

protected UtteranceProcessor getAudioOutput() throws IOException
Returns the audio output used by this voice.

Overrides:
  `getAudioOutput` in class `CMUVoice`
Returns:
  the audio output used by this voice
Throws:
  `IOException` - if an I/O error occurs

### getResource

protected URL getResource(String resource)
Get a resource for this voice. Resources for this voice are located in the package `com.sun.speech.freetts.en.us`.

Overrides:
  `getResource` in class `Voice`

### toString

public String toString()
Converts this object to a string

Overrides:
  `toString` in class `CMUVoice`
Returns:
  a string representation of this object